program pre_alloc_test
#include <petsc/finclude/petscmat.h>
  use petscmat
  use mpi
  use ISO_C_BINDING  

  implicit none
  
  Mat :: A1, A2, preM
  
  real(C_double) :: info(MAT_INFO_SIZE)
  
  integer :: ierr, ii(1), jj(1), n, m, inode, nnodes
  
  character(256) :: outstr
  
  
  call PetscInitialize(PETSC_NULL_CHARACTER,ierr)
  
  call MPI_COMM_SIZE(PETSC_COMM_WORLD, nnodes,ierr)
  call MPI_Comm_rank(PETSC_COMM_WORLD, inode, ierr )

  n=4
  m=n


  call MatCreate(PETSC_COMM_WORLD, preM, ierr)
  call MatSetType(preM, MATPREALLOCATOR, ierr)
  call MatSetSizes(preM, 2 , PETSC_DECIDE, n, m, ierr)  
  call MatSetup(preM, ierr)
  
  if (inode.eq.0) then
    ii=0
    jj=0
    call MatSetValues(preM, 1, ii, 1, jj, PETSC_NULL_SCALAR, &
          INSERT_VALUES, ierr)
    ii=0
    jj=1
    call MatSetValues(preM, 1, ii, 1, jj, PETSC_NULL_SCALAR, &
          INSERT_VALUES, ierr)
    ii=0
    jj=2
    call MatSetValues(preM, 1, ii, 1, jj, PETSC_NULL_SCALAR, &
          INSERT_VALUES, ierr)          
    ii=3
    jj=3
    call MatSetValues(preM, 1, ii, 1, jj, PETSC_NULL_SCALAR, &
          INSERT_VALUES, ierr)          
  end if
  
  call MatAssemblyBegin(preM, MAT_FINAL_ASSEMBLY, ierr)
  call MatAssemblyEnd(preM, MAT_FINAL_ASSEMBLY, ierr)

  
  call MatCreate(PETSC_COMM_WORLD, A1, ierr)
  call MatSetSizes(A1, 2 , PETSC_DECIDE, n, m, ierr)
  call MatSetType(A1, MATMPIAIJ, ierr)
  call MatPreallocatorPreallocate(preM, PETSC_TRUE, A1, ierr)
  call MatGetInfo(A1, MAT_LOCAL, info,ierr)
  write(outstr,*) "A1 ",inode, int(info(mat_info_nz_allocated)), int(info(mat_info_nz_used))
  call PetscSynchronizedPrintf(PETSC_COMM_WORLD,trim(outstr)//NEW_LINE('A'),ierr)
  call PetscSynchronizedFlush(PETSC_COMM_WORLD,PETSC_STDOUT,ierr)    
  
  call MatCreate(PETSC_COMM_WORLD, A2, ierr)
  call MatSetSizes(A2, 2 , PETSC_DECIDE, n, m, ierr)
  call MatSetType(A2, MATMPIAIJ, ierr)
  call MatPreallocatorPreallocate(preM, PETSC_TRUE, A2, ierr)
  call MatGetInfo(A2, MAT_LOCAL, info,ierr)
  write(outstr,*) "A2 ",inode, int(info(mat_info_nz_allocated)), int(info(mat_info_nz_used))
  call PetscSynchronizedPrintf(PETSC_COMM_WORLD,trim(outstr)//NEW_LINE('A'),ierr)
  call PetscSynchronizedFlush(PETSC_COMM_WORLD,PETSC_STDOUT,ierr)    

end program pre_alloc_test
